package org.jboss.soa.esb.samples.quickstart.message_xslt_node;

import org.jboss.soa.esb.actions.transformation.xslt.SourceResult;
import org.jboss.soa.esb.couriers.FaultMessageException;
import org.jboss.soa.esb.message.Message;
import org.jboss.soa.esb.qa.framework.ESBTestServices;
import org.jboss.soa.esb.qa.framework.SendESBMessage;
import org.testng.Assert;
import org.testng.annotations.AfterClass;
import org.testng.annotations.AfterMethod;
import org.testng.annotations.BeforeClass;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

@Test(groups = {"integtest"}, enabled = true)
public class XsltNodeTransformationTest {

   private static final String PACKAGE_NAME = "Quickstart_message_xslt_node.esb";
   private static final String VALID_MESSAGE = "/messages/xslt-valid.xml";
   private static final String EXPECTED_MESSAGE = "Title;artist#Empire Burlesque;Bob Dylan";
   private ESBTestServices testServices = null;

   @BeforeClass
   public void setupClass() throws Exception {
      testServices = new ESBTestServices(XsltNodeTransformationTest.class);
      testServices.deployESBApplication(PACKAGE_NAME);
      testServices.clearQueues();
   }

   @AfterClass
   public void tearDownClass() throws Exception {
      testServices.undeployESBApplication(PACKAGE_NAME);
      testServices.cleanup();
   }

   @BeforeMethod
   public void setupMethod() throws Exception {
      testServices.init();
   }

   @AfterMethod
   public void tearDownMethod() throws Exception {
   }

   @Test(groups = {"basic"}, timeOut = 60000, enabled = true)
   public void testStringMessage() throws Exception {
      final String request = testServices.readAsciiResource(VALID_MESSAGE);
      Message result = testServices.sendSyncESBTextMessage("transformation", "transform", request);
      Assert.assertEquals(result.getBody().get(), EXPECTED_MESSAGE);
   }
}
